Summary:	QEMU CPU Emulator
Name:		qemu
Version:	1.1.1
%define qemu_snapshot	1
#Release:	%{?qemu_snapshot:0.%{qemu_snapshot}.}1
Release:	1
Source0:	http://wiki.qemu.org/download/%{name}-%{version}.tar.gz
#Source0:	http://wiki.qemu.org/download/%{name}-%{version}%{?qemu_snapshot:-%{qemu_snapshot}}.tar.bz2

Source1:	kvm.modules

# KSM control scripts
Source4:	ksm.init
Source5:	ksm.sysconfig
Source6:	ksmtuned.init
Source7:	ksmtuned
Source8:	ksmtuned.conf

Source100:	qemu.rpmlintrc

License:	GPLv2+ and LGPLv2+ and BSD
URL:		http://wiki.qemu.org/Main_Page
Group:		Emulators
%rename		kvm
Requires:	qemu-img = %{EVRD}
# for %%{_sysconfdir}/sasl2
Requires:	cyrus-sasl
BuildRequires:	pkgconfig(sdl)
BuildRequires:	texi2html
# XXXX: -luuid
BuildRequires:	pkgconfig(ext2fs)
BuildRequires:	kernel-headers
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig
BuildRequires:	brlapi-devel
BuildRequires:	pkgconfig(gnutls) >= 3.0
BuildRequires:	libsasl2-devel
BuildRequires:	pkgconfig(libpci)
BuildRequires:	pkgconfig(libpng15)
BuildRequires:	texinfo
# not in main
#BuildRequires:	vde-devel
BuildRequires:	dev86
BuildRequires:	iasl
# glibc-devel with fixed preadv/pwritev prototypes
BuildRequires:	glibc-devel >= 6:2.10.1-7mnb2
ExclusiveArch:	%{ix86} ppc x86_64 amd64 %{sparcx}

%description
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation. QEMU has two operating modes:

* Full system emulation. In this mode, QEMU emulates a full system (for
  example a PC), including a processor and various peripherials. It can be
  used to launch different Operating Systems without rebooting the PC or
  to debug system code.
* User mode emulation. In this mode, QEMU can launch Linux processes compiled
  for one CPU on another CPU.

As QEMU requires no host kernel patches to run, it is safe and easy to use.

%package	img
Summary:	QEMU disk image utility
Group:		Emulators
Conflicts:	qemu < 0.9.0-3

%description	img
This package contains the QEMU disk image utility that is used to
create, commit, convert and get information from a disk image.

%prep
%setup -q

%build
#(proyvind): binutils upstream bug #10862, linking with gold fails if doing parallel build
mkdir -p bfd
ln -s %{_bindir}/ld.bfd bfd/ld
export PATH=$PWD/bfd:$PATH

%ifarch %{ix86} x86_64
# sdl outputs to alsa or pulseaudio depending on system config, but it's broken (RH bug #495964)
# alsa works, but causes huge CPU load due to bugs
# oss works, but is very problematic because it grabs exclusive control of the device causing other apps to go haywire
./configure \
	--target-list=x86_64-softmmu \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir} \
	--audio-drv-list=pa,sdl,alsa,oss \
	--disable-strip \
	--extra-ldflags="%{ldflags}" \
	--extra-cflags="%{optflags}" \
	--enable-vnc-png

%make V=1
cp -a x86_64-softmmu/qemu-system-x86_64 qemu-kvm
make clean

#pushd kvm
#./configure \
#	--prefix=%{_prefix} \
#	--kerneldir="`pwd`/../kernel/" \
#	--with-kvm-trace
##make kvmtrace
#make
#popd
%endif

./configure \
	--target-list="i386-softmmu x86_64-softmmu arm-softmmu cris-softmmu m68k-softmmu \
		mips-softmmu mipsel-softmmu mips64-softmmu mips64el-softmmu ppc-softmmu \
		ppcemb-softmmu ppc64-softmmu sh4-softmmu sh4eb-softmmu sparc-softmmu \
		i386-linux-user x86_64-linux-user alpha-linux-user arm-linux-user \
		armeb-linux-user cris-linux-user m68k-linux-user mips-linux-user \
		mipsel-linux-user ppc-linux-user ppc64-linux-user ppc64abi32-linux-user \
		sh4-linux-user sh4eb-linux-user sparc-linux-user sparc64-linux-user \
		sparc32plus-linux-user" \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir} \
	--interp-prefix=%{_prefix}/qemu-%%M \
	--audio-drv-list=pa,sdl,alsa,oss \
	--disable-kvm \
	--disable-strip \
	--extra-ldflags="%{ldflags}" \
	--extra-cflags="%{optflags}" \
	--enable-vnc-png

%make V=1

%install
install -D -p -m 0755 %{SOURCE4} %{buildroot}%{_initrddir}/ksm
install -D -p -m 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/ksm

install -D -p -m 0755 %{SOURCE6} %{buildroot}%{_initrddir}/ksmtuned
install -D -p -m 0755 %{SOURCE7} %{buildroot}%{_sbindir}/ksmtuned
install -D -p -m 0644 %{SOURCE8} %{buildroot}%{_sysconfdir}/ksmtuned.conf

%ifarch %{ix86} x86_64
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/modules
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_datadir}/%{name}

install -m 0755 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/modules/kvm.modules
install -m 0755 scripts/kvm/kvm_stat %{buildroot}%{_bindir}
install -m 0755 qemu-kvm %{buildroot}%{_bindir}
%endif

%makeinstall_std BUILD_DOCS="yes"

install -D -p -m 0644 qemu.sasl %{buildroot}%{_sysconfdir}/sasl2/qemu.conf

#QPM
install -m 0755 QMP/qmp-shell %{buildroot}%{_bindir}/qmp-shell
install -d %{buildroot}%{py_platsitedir}
install -m 0755 QMP/qmp.py %{buildroot}%{py_platsitedir}/qmp.py

# remove unpackaged files
rm -rf %{buildroot}%{_docdir}/qemu

%post 
%ifarch %{ix86} x86_64
# load kvm modules now, so we can make sure no reboot is needed.
# If there's already a kvm module installed, we don't mess with it
sh /%{_sysconfdir}/sysconfig/modules/kvm.modules
%endif
%_post_service ksmtuned
%_post_service ksm

%preun
%_preun_service ksm
%_preun_service ksmtuned

%triggerpostun -- qemu < 0.10.4-6
rm -f /etc/rc.d/*/{K,S}??qemu

%files
%doc README qemu-doc.html qemu-tech.html
%config(noreplace)%{_sysconfdir}/sasl2/qemu.conf
%{_initrddir}/ksm
%config(noreplace) %{_sysconfdir}/sysconfig/ksm
%{_initrddir}/ksmtuned
%{_sbindir}/ksmtuned
%config(noreplace) %{_sysconfdir}/ksmtuned.conf
%{_sysconfdir}/sysconfig/modules/kvm.modules
%{_sysconfdir}/qemu/target-x86_64.conf
%{_bindir}/kvm_stat
%{_bindir}/qemu-io
%{_bindir}/qemu-kvm
%{_bindir}/qemu-alpha
%{_bindir}/qemu-arm*
%{_bindir}/qemu-cris
%{_bindir}/qemu-ga
%{_bindir}/qemu-i386
%{_bindir}/qemu-m68k
%{_bindir}/qemu-mips*
%{_bindir}/qemu-nbd
%{_bindir}/qemu-ppc*
%{_bindir}/qemu-sh4*
%{_bindir}/qemu-sparc*
%{_bindir}/qemu-x86_64
%{_bindir}/qemu-system-arm
%{_bindir}/qemu-system-cris
%{_bindir}/qemu-system-i386
%{_bindir}/qemu-system-m68k
%{_bindir}/qemu-system-sh4*
%{_bindir}/qemu-system-ppc*
%{_bindir}/qemu-system-mips*
%{_bindir}/qemu-system-sparc
%{_bindir}/qemu-system-x86_64
%{_bindir}/qmp-shell
%{_bindir}/virtfs-proxy-helper
%{_mandir}/man1/qemu.1*
%{_mandir}/man1/virtfs-proxy-helper.1*
%{_mandir}/man8/qemu-nbd.8*
%{_prefix}/libexec/qemu-bridge-helper
%dir %{_datadir}/qemu
%{_datadir}/qemu/*.bin
%{_datadir}/qemu/*.rom
%{_datadir}/qemu/cpus-x86_64.conf
%{_datadir}/qemu/keymaps
%{_datadir}/qemu/openbios-sparc32
%{_datadir}/qemu/openbios-sparc64
%{_datadir}/qemu/openbios-ppc
%{_datadir}/qemu/bamboo.dtb
%{_datadir}/qemu/mpc8544ds.dtb
%{_datadir}/qemu/palcode-clipper
%{_datadir}/qemu/petalogix-ml605.dtb
%{_datadir}/qemu/petalogix-s3adsp1800.dtb
%{_datadir}/qemu/qemu-icon.bmp
%{py_platsitedir}/qmp.py

%files img
%{_bindir}/qemu-img
%{_mandir}/man1/qemu-img.1*


%changelog
* Tue Jul 17 2012 Alexander Khrukin <akhrukin@mandriva.org> 1.1.1-1
+ Revision: 810024
- version update 1.1.1

* Wed Jul 04 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 1.1.0-0.1.1
+ Revision: 808118
- build with standar %%optflags & %%ldflags
- workaround gold linker issue, use bfd linker for now...
- update source download url
- new version

  + Alexander Khrukin <akhrukin@mandriva.org>
    - version update 1.0.1

* Fri Mar 23 2012 Bernhard Rosenkraenzer <bero@bero.eu> 1.0-2
+ Revision: 786453
- Fix build in current environment; build w/ gnutls 3.x

* Tue Jan 17 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 1.0-1
+ Revision: 761933
- leave stripping to find-debuginfo.sh so that we get working debug package
- update license
- use %%{EVRD} macro
- use %%rename macro
- use pkgconfig() dependencies in buildrequires
- apply cosmetics
- drop no longer needed __find_requires workaround
- update %%files
- ditvch deprecated legacy rpm stuff
- s/sunsparc/sparcx/
- drop check for gcc -mtune option
- update description
- new version

* Wed Aug 31 2011 Lonyai Gergely <aleph@mandriva.org> 0.15.0-2
+ Revision: 697634
- CCBUG: 64115
  Add new configure option: --enable-vnc-png

* Mon Aug 22 2011 Lonyai Gergely <aleph@mandriva.org> 0.15.0-1
+ Revision: 696141
- 0.15.0
  Drop applied patch in upstream: Patch2, Patch3

* Mon Jul 25 2011 Franck Bui <franck.bui@mandriva.com> 0.14.1-1
+ Revision: 691587
- Update to v0.14.1

* Mon Jul 25 2011 Franck Bui <franck.bui@mandriva.com> 0.14.0-2
+ Revision: 691582
- 0.14.1: ARM: add patches to implement SYS_CLCD register

  + Bogdano Arendartchuk <bogdano@mandriva.com>
    - no need to use texi2html from tetex

* Fri Apr 01 2011 Buchan Milne <bgmilne@mandriva.org> 0.14.0-1
+ Revision: 649573
- Use %%_initrddir instead of %%_initddir
- Fix build of non-x86 targets which dont have PCI support

  + Lonyai Gergely <aleph@mandriva.org>
    - 0.14.0

* Sat Dec 04 2010 Lonyai Gergely <aleph@mandriva.org> 0.13.0-1mdv2011.0
+ Revision: 608879
- Fix the sysconfdir param
- Add some files to %%files
- try the official doc/man install
- Install manualy the man pages.
- Install manualy qemu manpage
- Does not run compile in the user dir
- Disable the kvm_trace tool.
- 0.13.0

  + Funda Wang <fwang@mandriva.org>
    - br makeinfo

  + Thierry Vignaud <tv@mandriva.org>
    - fix outdated URL

* Wed Aug 25 2010 Guillaume Rousse <guillomovitch@mandriva.org> 0.12.5-1mdv2011.0
+ Revision: 573124
- new version

* Fri Jul 16 2010 Funda Wang <fwang@mandriva.org> 0.12.4-1mdv2011.0
+ Revision: 553901
- New version 0.12.4

* Mon Mar 01 2010 Frederic Crozat <fcrozat@mandriva.com> 0.12.3-2mdv2010.1
+ Revision: 512912
- Ensure kvm modules autoload can be blacklisted (Fedora)

* Sun Feb 28 2010 Frederik Himpe <fhimpe@mandriva.org> 0.12.3-1mdv2010.1
+ Revision: 512672
- Update to new version 0.12.3

* Thu Jan 21 2010 Frederik Himpe <fhimpe@mandriva.org> 0.12.2-1mdv2010.1
+ Revision: 494681
- Update to new version 0.12.2

* Fri Jan 01 2010 Frederik Himpe <fhimpe@mandriva.org> 0.12.1.2-1mdv2010.1
+ Revision: 484859
- Update to new version 0.12.1.2
- Remove old patches

* Tue Dec 15 2009 Frederik Himpe <fhimpe@mandriva.org> 0.11.1-1mdv2010.1
+ Revision: 479125
- Update to new version 0.11.1
- Enable KSM support now that we have Linux 2.6.32 with KSM support
  (from Fedora)

* Mon Nov 23 2009 Pascal Terjan <pterjan@mandriva.org> 0.11.0-5mdv2010.1
+ Revision: 469231
- Drop kqemu support, it is now broken so no reason to limit supported memory in kvm

* Thu Nov 12 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.11.0-4mdv2010.1
+ Revision: 465471
- Rebuild with latest glibc-devel (fixed preadv/pwritev prototypes).

* Wed Oct 14 2009 Frederik Himpe <fhimpe@mandriva.org> 0.11.0-3mdv2010.0
+ Revision: 457437
- Add Fedora patch to Fix fs errors with virtio and qcow2 backing file
  (RH bug #524734)

* Sun Oct 04 2009 Frederik Himpe <fhimpe@mandriva.org> 0.11.0-2mdv2010.0
+ Revision: 453566
- Sync patches with Fedora

* Thu Oct 01 2009 Frederik Himpe <fhimpe@mandriva.org> 0.11.0-1mdv2010.0
+ Revision: 452301
- Update to new version 0.11.0 final

* Mon Sep 14 2009 Frederik Himpe <fhimpe@mandriva.org> 0.11.0-0.rc2.2mdv2010.0
+ Revision: 441019
- Update to new version 0.11.0-rc2
- Remove patched included upstream

* Sat Aug 08 2009 Frederik Himpe <fhimpe@mandriva.org> 0.11.0-0.rc2.1mdv2010.0
+ Revision: 411756
- Remove warning about permissions on KVM device, now udev only
  gives access to console users

* Sat Aug 08 2009 Frederik Himpe <fhimpe@mandriva.org> 0.10.6-1mdv2010.0
+ Revision: 411755
- Don't package udev rules, /lib/udev/rules.d/70-acl.rules from udev
  package now takes care of this
- Update to new version 0.10.6

* Wed Jul 01 2009 Pascal Terjan <pterjan@mandriva.org> 0.10.5-1mdv2010.0
+ Revision: 391268
- Enable kqemu support
- Update to 0.10.5

* Sun May 24 2009 Frederik Himpe <fhimpe@mandriva.org> 0.10.4-7mdv2010.0
+ Revision: 379273
- Correct sasl BuildRequires
- Add warning about security issue with /dev/kvm being accessible by
  non-root users
- Add KVM udev rules to let normal users use KVM
- Mark configuration files as %%config(noreplace)
- Enable sasl authentication
- Sync patches with Fedora 11

* Sat May 23 2009 Frederik Himpe <fhimpe@mandriva.org> 0.10.4-6mdv2010.0
+ Revision: 379080
- Disable vde, it's not in main
- Add some BuildRequires (build with vde, brlapi and VNC/TLS support)
- Remove old qemu init script on upgrade
- Use qemu-kvm 0.10.4 sources
- Obsolete kvm
- Remove kqemu: it is unmaintained and unreliable
- Use /etc/sysconfig/modules/kvm.modules to load KVM kernel modules
- Merge %%build section from Fedora's qemu package: build qemu-kvm twice:
  once with KVM support for x86* and once without kvm support
- Add PPC patch from Fedora to fix build of PPC emulator
- Add patch fixing kerneldir includes from upstream git to fix build of KVM

* Tue May 12 2009 Frederik Himpe <fhimpe@mandriva.org> 0.10.4-5mdv2010.0
+ Revision: 375044
- Update to new version 0.10.4
- Update to new version 0.10.3
- Prefer sdl over alsa because sound with alsa is choppy

* Sun Mar 22 2009 Frederik Himpe <fhimpe@mandriva.org> 0.10.1-3mdv2009.1
+ Revision: 360260
- Update to new version 0.10.1

* Fri Mar 06 2009 Pascal Terjan <pterjan@mandriva.org> 0.10.0-2mdv2009.1
+ Revision: 349652
- Update to 0.10.0
- Enable ppc again

* Wed Feb 04 2009 Guillaume Rousse <guillomovitch@mandriva.org> 0.9.1-0.r5137.2mdv2009.1
+ Revision: 337395
- rediff vga patch
- keep bash completion in its own package

* Mon Sep 08 2008 Pascal Terjan <pterjan@mandriva.org> 0.9.1-0.r5137.1mdv2009.0
+ Revision: 282565
- Update to svn snapshot
- Drop KVM support (to be packaged separatly)
- Disable ppc for now

* Tue Apr 01 2008 Pascal Terjan <pterjan@mandriva.org> 0.9.0-18mdv2008.1
+ Revision: 191380
- try SDL, alsa, oss instead of oss, alsa, SDL

  + Anssi Hannula <anssi@mandriva.org>
    - add a comment regarding _requires_exceptions

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Dec 08 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.9.0-17mdv2008.1
+ Revision: 116405
- backport OHCI & UHCI iso transfer support from git (should make webcams usable :)
- fix typo in bash completion (modified S3)

* Mon Oct 01 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-16mdv2008.0
+ Revision: 94272
- Add a link /usr/bin/qemu-kvm for compatibility with some other distros

* Sat Sep 22 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-15mdv2008.0
+ Revision: 92233
- Have the completion to add the common prefix (really handy to change iso during install)

* Fri Sep 21 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-14mdv2008.0
+ Revision: 91894
- Enable alsa support (and don't disable gcc version check twice)

* Mon Sep 17 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-13mdv2008.0
+ Revision: 89251
- Add mipsel system emulation

* Thu Sep 06 2007 Olivier Blin <blino@mandriva.org> 0.9.0-12mdv2008.0
+ Revision: 80664
- fix "HSM violation" bug in ATAPI cdrom driver (from qemu CVS, Novell #291775, Ubuntu #120316)

* Mon Aug 20 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-11mdv2008.0
+ Revision: 67355
- Turn Requires dkms-kqemu into a Suggest

* Mon Aug 20 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-10mdv2008.0
+ Revision: 67187
- Drop cpu-vendor option from kvm patch for now, it breaks build on x86_64
- Update to kvm-35
- Add a patch from the ML to support USB devices with several interfaces

* Fri Aug 10 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-9mdv2008.0
+ Revision: 61527
- Adapt the PXE patches and apply them

  + Erwan Velu <erwan@mandriva.org>
    - Adding patches to make pxe working

* Sat Jun 30 2007 Olivier Blin <blino@mandriva.org> 0.9.0-8mdv2008.0
+ Revision: 46094
- fix __find_requires macro override
- really package bash_completion file (and thus fix build)
- do not mark initscript as config file

  + Guillaume Rousse <guillomovitch@mandriva.org>
    - bash completion

* Fri Apr 20 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 0.9.0-7mdv2008.0
+ Revision: 16259
- rewrite patches for gcc4 support and use it everywhere

* Wed Apr 18 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 0.9.0-6mdv2008.0
+ Revision: 14738
- fix pgtable calculation for 32-bit code under x86_64 (Bernhard Kauer)
- fix qcow2 image corruption, refcount table (Juergen Keil)
- fix build with gcc3.3 (Windows XP in i386-softmmu)

